SUBROUTINE Branch_one
!
!**** Branch_one : PALM BRANCH MODULE
!
!     Purpose:
!     --------
!
!     File generated by PrePALM user: andrea 
!                               date: 2008 Monday 03 November 10:30 
!     Don't edit this file!
!
!     History:
!     --------
!
!      Version    Programmer      Date         Description
!      -------    ----------      ----         -----------
!       0.0.0     andrea         11/03/08         created
!
!*--------------------------------------------------------------------------
!
!** 1. DECLARATIONS
  USE palmlib
  USE palm_user_param
 
  IMPLICIT NONE
  INCLUDE "mpif.h"
 
!** 1.1. Local variables 
  CHARACTER(LEN=PL_LNAME) :: cl_name, cl_space, cl_unit
  INTEGER :: il_time, il_usrtag, il_nstep, il_err, il_err2exp
  CHARACTER(LEN=256) :: cl_argc
  CHARACTER(LEN=100) :: cl_form
 
!** 1.2. Work variables
 
!** 1.2.1. Automatic variables
  INTEGER :: ib_assim
  INTEGER :: ib_time
  INTEGER :: id_NEND
  INTEGER :: id_NITERT
  INTEGER :: id_NSCY
  INTEGER :: id_mode
  INTEGER :: id_obscount
  INTEGER :: id_obsmode
  INTEGER :: il_assimtime
  INTEGER :: il_fctend
  INTEGER :: il_fctstart
  INTEGER :: il_intdate0
  INTEGER :: il_nbofruns
  INTEGER :: il_obstot
  INTEGER :: il_pastassimtime
  INTEGER :: il_putend
  INTEGER :: il_putstart
  INTEGER :: il_tend
  INTEGER :: il_tstart
  REAL :: rd_DT
  REAL :: rd_Jo
  REAL :: rd_daynum
  REAL :: rd_daynum0
  REAL :: rl_J_last
 
!** 1.2.2. User variables
 
  LOGICAL :: ll_firststart
  LOGICAL :: ld_noobs
  LOGICAL :: ll_nooverlap
  INTEGER :: il_SELAPS
  INTEGER :: il_DELAPS
  INTEGER :: il_HELAPS
  INTEGER :: il_MELAPS
  INTEGER, DIMENSION(6) :: idate0
  INTEGER :: id_NSECCY
  INTEGER :: il_assimiter
  INTEGER :: il_gsize
  LOGICAL :: ll_transfer
  CHARACTER(LEN=80) :: cl_gname, cl_fileout
  LOGICAL :: ld_finish
 
!*--------------------------------------------------------------------------
!
!** 2. STATMENTS
 
!  Loop on the assimilation windows
  ll_firststart = .TRUE.
  ld_noobs = .TRUE.
  IF(ip_niter .gt. 0) THEN
     il_nbofruns = ip_nbfenet
  ELSE
     il_nbofruns = 1
  END IF
 
 
  DO ib_assim = 1 , il_nbofruns
     IF( ll_firststart ) THEN
!        Launch observation branch for initialization
        id_obsmode = 0
 
        !Put object Branch_one_put_4
        cl_space  = 'one_integer'
        cl_name   = 'Branch_one_put_4'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, id_obsmode, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_4,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
 
        !**START Branch --> Branch_obs
        cl_name = 'Branch_obs'
        CALL PALM_Start(cl_name, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_Start, branch Branch_obs'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
        IF( ip_scrip .eq. 1) THEN
           ll_transfer = ((ip_gauss_modelgrid.EQ.0).OR.&
           	 ((ip_gauss_modelgrid.EQ.1).AND.&
           	 ((ip_lonm1.NE.ip_lonc1).OR.(ip_latm1.NE.ip_latc1))))
           IF(ll_transfer) THEN
!              odel grid description
              il_gsize=ip_lonm1*ip_latm1
              cl_fileout='model_grid.nc'
              IF( ip_gauss_modelgrid .eq. 1) THEN
                 cl_gname='Gauss model grid'
                 call convert_gauss(ip_lonm1,ip_latm1,il_gsize,cl_gname,cl_fileout)
              ELSE
                 cl_gname='Regular model grid'
                 call create_latlon(ip_lonm1,ip_latm1,il_gsize,cl_gname,cl_fileout)
              END IF
 
!              ontrol grid description
              il_gsize=ip_lonc1*ip_latc1
              cl_gname='Gauss control grid'
              cl_fileout='control_grid.nc'
              call convert_gauss(ip_lonc1,ip_latc1,il_gsize,cl_gname,cl_fileout)
!              Generate remapping matrices
              call scrip
           END IF
 
        END IF
 
!        Invoke grid transform initialization
!        Launch model initialization
 
        !**Launch unit --> INIT
        cl_unit = 'INIT'
        CALL PALM_Launch(cl_unit, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_Launch, unit INIT'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
        !Get object Branch_one_get_4
        cl_space  = 'one_real'
        cl_name   = 'Branch_one_get_4'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, rd_daynum0, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_GET(one_real,Branch_one_get_4,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
 
        !Get object Branch_one_get_1
        cl_space  = 'one_real'
        cl_name   = 'Branch_one_get_1'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, rd_DT, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_GET(one_real,Branch_one_get_1,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
 
        !Get object Branch_one_get_3
        cl_space  = 'one_integer'
        cl_name   = 'Branch_one_get_3'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, id_NEND, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_GET(one_integer,Branch_one_get_3,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
 
        !Get object Branch_one_get_5
        cl_space  = 'one_integer'
        cl_name   = 'Branch_one_get_5'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, id_NSCY, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_GET(one_integer,Branch_one_get_5,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
 
        !Get object Branch_one_get_6
        cl_space  = 'one_integer'
        cl_name   = 'Branch_one_get_6'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, id_NITERT, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_GET(one_integer,Branch_one_get_6,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
!        Test if MOCAGE parameters match with PALM parameters
        IF ((ip_nbfenet*ip_fenetre) .GT. id_NEND) THEN
            WRITE(PL_OUT,'(A56)') '++ ERROR: PALM PARAMETERS DO NOT MATCH MOCAGE PARAMETERS'
            CALL flush(PL_OUT)
            CALL PALM_Abort(il_err)
        ENDIF
!        Set initial time and firststart
        il_tstart = rd_daynum0
        WRITE(*,"('++')")
        WRITE(*,"('++ Starting the assimilation process')")
        WRITE(*,"('++ The first model run starts at ',I5)")il_tstart
        WRITE(*,"('++')")
        WRITE(PL_OUT,"('++')")
        WRITE(PL_OUT,"('++ Starting the assimilation process')")
        WRITE(PL_OUT,"('++ The first model run starts at ',I5)")il_tstart
        WRITE(PL_OUT,"('++')")
        IF (ip_omd .EQ. 0) THEN
          il_tend = ib_assim * ip_fenetre
        ELSE
          il_tend = id_NEND
        ENDIF
        ll_firststart = .FALSE.
     ELSE
!        Set initial time
        IF(ld_noobs) THEN
              il_tstart = rd_daynum0 + (ib_assim - 1)*ip_fenetre
              WRITE(PL_OUT,"('++ Restarting after an assimilation window with no obs')")
              WRITE(PL_OUT,"('++ No need of overlapping : resuming from time ',I5)")il_tstart
              WRITE(PL_OUT,"('++')")
              WRITE(*,"('++ Restarting after an assimilation window with no obs')")
              WRITE(*,"('++ No need of overlapping : resuming from time ',I5)")il_tstart
              WRITE(*,"('++')")
        ELSE
              il_tstart = rd_daynum0 + ip_correctime + (ib_assim - 2)*ip_fenetre
              WRITE(PL_OUT,"('++ Restarting after a succesful analysis')")
              WRITE(PL_OUT,"('++ Inserting correction at time ',I5)")il_tstart
              WRITE(PL_OUT,"('++')")
              WRITE(*,"('++ Restarting after a succesful analysis')")
              WRITE(*,"('++ Inserting correction at time ',I5)")il_tstart
              WRITE(*,"('++')")
        ENDIF
        il_tend = ib_assim * ip_fenetre
     END IF
 
!     ompute times for the assimilation windows
     il_assimtime = ip_correctime + (ib_assim - 1)*ip_fenetre
     IF (.NOT.ld_noobs) THEN
         il_pastassimtime = ip_correctime + (ib_assim - 2)*ip_fenetre
     ELSE
         il_pastassimtime = PL_NO_TIME
     ENDIF
     il_fctstart = int(rd_daynum0) + (ib_assim-1)*ip_fenetre
     il_putstart = il_fctstart
     IF (ip_oma.eq.1) il_putstart=il_tstart
     il_fctend = int(rd_daynum0) + ib_assim*ip_fenetre
     il_putend = il_fctend
     IF (ip_omd .eq. 1 .and. ib_assim .eq. 1) il_putend = il_tend
!     Set logicals
     ld_noobs = .TRUE.
     ld_finish = .FALSE.
     WRITE(PL_OUT,"('++ ASSIMILATION WINDOWS NUMBER ',I3)") ib_assim
     WRITE(PL_OUT,"('++   Restarting for balancing from ',I5)") il_tstart
     WRITE(PL_OUT,"('++   New analisys from ',I5,' to ',I5)") &
        INT(rd_daynum0)+(ib_assim-1)*ip_fenetre, INT(rd_daynum0)+il_fctend
     WRITE(PL_OUT,"('++')")
     WRITE(*,"('++ ASSIMILATION WINDOWS NUMBER ',I3)") ib_assim
     WRITE(*,"('++   Restarting for balancing from ',I5)") il_tstart
     WRITE(*,"('++   New analisys from ',I5,' to ',I5)") &
        INT(rd_daynum0)+(ib_assim-1)*ip_fenetre, INT(rd_daynum0)+il_fctend
     WRITE(*,"('++')")
!     Put the number of the assimilation windows
 
     !Put object Branch_one_put_17
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_17'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, ib_assim, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_17,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_26
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_26'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_assimtime, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_26,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_32
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_32'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_pastassimtime, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_32,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
!     Launch Branch Obs for computing H(x) and H.dx
 
     !**START Branch --> Branch_obs
     cl_name = 'Branch_obs'
     CALL PALM_Start(cl_name, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_Start, branch Branch_obs'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
     id_obsmode = 1
 
     !Put object Branch_one_put_5
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_5'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, id_obsmode, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_5,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_7
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_7'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_tstart, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_7,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_19
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_19'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_tend, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_19,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_6
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_6'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_fctstart, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_6,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_10
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_10'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_fctend, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_10,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_1
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_1'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_putstart, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_1,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_35
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_35'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_putend, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_35,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !**Launch unit --> MODEL
     cl_unit = 'MODEL'
     CALL PALM_Launch(cl_unit, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_Launch, unit MODEL'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
     il_obstot = 0
     WRITE(*,"('++')")
     WRITE(PL_OUT,"('++')")
 
     DO ib_time = il_fctstart , il_fctend-ip_obs_slot, ip_obs_slot
!        Get the number of observation for curent step
 
        !Get object Branch_one_get_10
        cl_space  = 'one_integer'
        cl_name   = 'Branch_one_get_10'
        il_time   = ib_time
        il_usrtag = PL_NO_TAG
        CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, id_obscount, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_GET(one_integer,Branch_one_get_10,ib_time,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
        if (id_obscount.GT.0) ld_noobs = .FALSE.
        WRITE(PL_OUT,"('++ number of observations in time slot [',I5,' - ',I5,'] = ',I5)") &
            ib_time,ib_time+ip_obs_slot,id_obscount
        il_obstot = il_obstot+id_obscount
 
     ENDDO
 
     IF(ip_niter .gt. 0) THEN
        IF((.NOT. ld_noobs)) THEN
!           Initialisation avant la boucle interne
           WRITE(*,"('++')")
           WRITE(*,"('++ INNER LOOP BEGINS')")
           WRITE(*,"('++')")
           WRITE(PL_OUT,"('++')")
           WRITE(PL_OUT,"('++ INNER LOOP BEGINS')")
           WRITE(PL_OUT,"('++')")
           IF(ib_assim .eq. 1 .and. (id_NEND - rd_daynum0) .gt. 86400. .and. ip_omd .ne. 0 ) THEN
!              Re-initialization of observations
              id_obsmode = 0
              rd_daynum = rd_daynum0 + (ib_assim-1)*ip_fenetre
 
              !Put object Branch_one_put_18
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_18'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, id_obsmode, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_18,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !Put object Branch_one_put_33
              cl_space  = 'one_real'
              cl_name   = 'Branch_one_put_33'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, rd_daynum, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_real,Branch_one_put_33,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !**START Branch --> Branch_obs
              cl_name = 'Branch_obs'
              CALL PALM_Start(cl_name, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Start, branch Branch_obs'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
           END IF
 
!           ompute the background error statistics
 
           !**Launch unit --> INISTATS
           cl_unit = 'INISTATS'
           CALL PALM_Launch(cl_unit, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Launch, unit INISTATS'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
!           Set the initial value of vector v to 0. 
 
           !**Launch unit --> p_sigma_to_gauss
           cl_unit = 'p_sigma_to_gauss'
           CALL PALM_Launch(cl_unit, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Launch, unit p_sigma_to_gauss'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
           !**Launch unit --> INITv
           cl_unit = 'INITv'
           CALL PALM_Launch(cl_unit, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Launch, unit INITv'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
!           ounters Initialization
           id_mode=4
           il_assimiter=0
!           Start and end times modification
           il_tstart = rd_daynum0 + (ib_assim-1)*ip_fenetre
           il_tend = ib_assim * ip_fenetre
           DO WHILE ( id_mode .gt. 1)
!              Put mode to LBFGS with mode=0 if first time
              IF (id_mode .eq. 4) id_mode = 0
 
              !Put object Branch_one_put_27
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_27'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_assimtime, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_27,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
!              Step to waiting for the computation of the cost function relative to background
 
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_Step(11, il_time, il_usrtag, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Step 11'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
!              hangement de variable pour le calcul de H.dx
 
              !Put object Branch_one_put_3
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_3'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_fctstart, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_3,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !Put object Branch_one_put_11
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_11'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_fctend, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_11,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !**Launch unit --> sqrtB
              cl_unit = 'sqrtB'
              CALL PALM_Launch(cl_unit, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Launch, unit sqrtB'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
!              alcul de y=H.dx 
 
              !**START Branch --> Branch_obs
              cl_name = 'Branch_obs'
              CALL PALM_Start(cl_name, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Start, branch Branch_obs'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
              id_obsmode=2
 
              !Put object Branch_one_put_13
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_13'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, id_obsmode, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_13,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !**Launch unit --> Fwd_TL
              cl_unit = 'Fwd_TL'
              CALL PALM_Launch(cl_unit, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Launch, unit Fwd_TL'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
              il_time   = il_fctend
              il_usrtag = PL_NO_TAG
              CALL PALM_Step(6, il_time, il_usrtag, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Step 6'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
!              alcul de DJi=Hi*.invR.(Hi.dx+di)
 
              !**START Branch --> Branch_obs
              cl_name = 'Branch_obs'
              CALL PALM_Start(cl_name, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Start, branch Branch_obs'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
              id_obsmode=3
 
              !Put object Branch_one_put_9
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_9'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, id_obsmode, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_9,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !**Launch unit --> Bkwd_ADJ
              cl_unit = 'Bkwd_ADJ'
              CALL PALM_Launch(cl_unit, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Launch, unit Bkwd_ADJ'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
              il_time   = il_fctstart
              il_usrtag = PL_NO_TAG
              CALL PALM_Step(4, il_time, il_usrtag, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Step 4'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
!              PUTE U^T.dJo where dJo = H^T.R^-1.(H.dx+dg)
 
              !**Launch unit --> sqrtB_T
              cl_unit = 'sqrtB_T'
              CALL PALM_Launch(cl_unit, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_Launch, unit sqrtB_T'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
!              Boucle de recuperation de J et du Gradient
 
              !Get object Branch_one_get_8
              cl_space  = 'one_real'
              cl_name   = 'Branch_one_get_8'
              il_time   = il_assimtime
              il_usrtag = PL_NO_TAG
              CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, rd_Jo, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_GET(one_real,Branch_one_get_8,il_assimtime,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
              WRITE(PL_OUT,'(A7,1PD20.14,A15,I3)')'++ J = ', rd_Jo,&
                                               ' at evaluation ', il_assimiter
              CALL flush(PL_OUT)
!              User Minimizer stopping criterium
              IF (il_assimiter .EQ. 0) THEN 
                rl_J_last = rd_Jo
              ELSE
                IF (ABS((rl_J_last - rd_Jo)/rd_Jo) .LT. 1.e-10) ld_finish = .TRUE.
                rl_J_last = rd_Jo  
              ENDIF
!              Launch the minimiser
 
              !Put object Branch_one_put_15
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_put_15'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, ip_dimx, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_15,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
 
              !Get object Branch_one_get_9
              cl_space  = 'one_integer'
              cl_name   = 'Branch_one_get_9'
              il_time   = PL_NO_TIME
              il_usrtag = PL_NO_TAG
              CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, id_mode, il_err)
              IF (il_err.ne.0) THEN
                  WRITE(PL_OUT,*)'Error in PALM_GET(one_integer,Branch_one_get_9,PL_NO_TIME,PL_NO_TAG)'
                  il_err2exp = il_err
                  CALL PALM_error_explain(il_err2exp, il_err)
                  CALL PALM_ABORT(il_err)
              END IF
 
              WRITE(PL_OUT,"('++ Minimiser return code = ',I2)") id_mode
              CALL flush(PL_OUT)
              WRITE(*,"('++ At evaluation nr. ',I3,'/',I3,' : J = ',F20.8)") &
                 il_assimiter,ip_niter, rd_Jo
              il_assimiter=il_assimiter+1
           ENDDO
 
 
           !**Launch unit --> sqrtB_fcst
           cl_unit = 'sqrtB_fcst'
           CALL PALM_Launch(cl_unit, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Launch, unit sqrtB_fcst'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
           !**Launch unit --> increment_to_model
           cl_unit = 'increment_to_model'
           CALL PALM_Launch(cl_unit, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Launch, unit increment_to_model'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
           !Put object Branch_one_put_23
           cl_space  = 'one_real'
           cl_name   = 'Branch_one_put_23'
           il_time   = il_assimtime
           il_usrtag = PL_NO_TAG
           CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, rl_J_last, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_PUT(one_real,Branch_one_put_23,il_assimtime,PL_NO_TAG)'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
 
           !Put object Branch_one_put_16
           cl_space  = 'one_integer'
           cl_name   = 'Branch_one_put_16'
           il_time   = il_assimtime
           il_usrtag = PL_NO_TAG
           CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_obstot, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_16,il_assimtime,PL_NO_TAG)'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
 
           !**Launch unit --> plot_inc
           cl_unit = 'plot_inc'
           CALL PALM_Launch(cl_unit, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Launch, unit plot_inc'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
           il_time   = ib_assim
           il_usrtag = 0
           CALL PALM_Step(5, il_time, il_usrtag, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Step 5'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
 
           !Get object Branch_one_get_2
           cl_space  = 'one_integer'
           cl_name   = 'Branch_one_get_2'
           il_time   = PL_NO_TIME
           il_usrtag = PL_NO_TAG
           CALL PALM_GET(cl_space, cl_name, il_time, il_usrtag, il_intdate0, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_GET(one_integer,Branch_one_get_2,PL_NO_TIME,PL_NO_TAG)'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
           il_time = il_assimtime+il_intdate0
           CALL PALM_Time_convert(PL_TIME_INT2DATE, idate0(3),&
              idate0(2), idate0(1), idate0(4), idate0(5), idate0(6), &
              il_time, il_err)
           IF (il_err.ne.0) THEN
              WRITE(PL_OUT,*)'Error in PALM_Time_convert'
              il_err2exp = il_err
              CALL PALM_error_explain(il_err2exp, il_err)
              CALL PALM_ABORT(il_err)
           END IF
           WRITE(*,'(A2)') '++'
           WRITE(*,'(A23,I2,A10)') '++ ASSIMILATION WINDOW ',ib_assim,' CONCLUDED'
           WRITE(*,'(A21,I4.4,1X,I2.2,1X,I2.2,1X,I2.2)') '++ Correction time = ',idate0(1:4)
           WRITE(*,'(A18)') '++ Talagrand check'
           WRITE(*,'(A7,F15.4)') '++ J = ',rl_J_last
           WRITE(*,'(A7,I6)') '++ p = ',il_obstot
           WRITE(*,'(A13,F9.6)') '++ J/(p/2) = ',2.*rl_J_last/REAL(il_obstot)
           WRITE(*,'(A2)') '++'
           WRITE(PL_OUT,'(A2)') '++'
           WRITE(PL_OUT,'(A23,I2,A10)') '++ ASSIMILATION WINDOW ',ib_assim,' CONCLUDED'
           WRITE(PL_OUT,'(A21,I4.4,1X,I2.2,1X,I2.2,1X,I2.2)') '++ Correction time = ',idate0(1:4)
           WRITE(PL_OUT,'(A18)') '++ Talagrand check'
           WRITE(PL_OUT,'(A7,F15.4)') '++ J = ',rl_J_last
           WRITE(PL_OUT,'(A7,I6)') '++ p = ',il_obstot
           WRITE(PL_OUT,'(A13,F9.6)') '++ J/(p/2) = ',2.*rl_J_last/REAL(il_obstot)
           WRITE(PL_OUT,'(A2)') '++'
        ELSE
 
           il_time   = ib_assim
           il_usrtag = 1
           CALL PALM_Step(5, il_time, il_usrtag, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Step 5'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
 
           il_time   = il_assimtime
           il_usrtag = ip_restart_on_dsk
           CALL PALM_Step(14, il_time, il_usrtag, il_err)
           IF (il_err.ne.0) THEN
               WRITE(PL_OUT,*)'Error in PALM_Step 14'
               il_err2exp = il_err
               CALL PALM_error_explain(il_err2exp, il_err)
               CALL PALM_ABORT(il_err)
           END IF
 
        END IF
 
     END IF
 
 
  ENDDO
 
  IF(ip_niter .gt. 0) THEN
!     Re-analysis
!     The analysis is just like a new assimilation windows 
     ib_assim=ip_nbfenet+1
!     ompute times for the analysis windows
     il_assimtime = ip_correctime + (ib_assim - 1)*ip_fenetre
     IF(ld_noobs) THEN
         il_tstart = rd_daynum0 + (ib_assim - 1)*ip_fenetre
         il_pastassimtime = PL_NO_TIME
         WRITE(PL_OUT,"('++ Final forecast after an assimilation window with no obs')")
         WRITE(PL_OUT,"('++ No need of overlapping : resuming from time ',I5)") il_tstart
         WRITE(PL_OUT,'(A2)') '++'
         WRITE(*,"('++ Final forecast after an assimilation window with no obs')")
         WRITE(*,"('++ No need of overlapping : resuming from time ',I5)") il_tstart
         WRITE(*,'(A2)') '++'
     ELSE
         il_tstart = rd_daynum0 + ip_correctime + (ib_assim - 2)*ip_fenetre
         il_pastassimtime = ip_correctime + (ib_assim - 2)*ip_fenetre
         WRITE(PL_OUT,"('++ Final forecast after a succesful analysis')")
         WRITE(PL_OUT,"('++ Restarting after correction at time ',I5)") il_tstart
         WRITE(PL_OUT,'(A2)') '++'
         WRITE(*,"('++ Final forecast after a succesful analysis')")
         WRITE(*,"('++ Restarting after correction at time ',I5)") il_tstart
         WRITE(*,'(A2)') '++'
     END IF
     il_tend = id_NEND
     IF (il_tstart .EQ. int(rd_daynum0) + il_tend) THEN
         il_tend = il_tend + int(2.*rd_DT)
         ll_nooverlap = .TRUE.
         ib_assim = - ib_assim !Workaround to tell M that ld_noobs
     ELSE
         ll_nooverlap = .FALSE.
     END IF
     il_putstart = il_tstart
     IF (ip_oma .ne. 1)  il_putstart = int(rd_daynum0) + il_tend + ip_obs_slot
     il_putend = int(rd_daynum0) + il_tend
     IF (ip_oma .ne. 1)  il_putend = int(rd_daynum0) + il_tend + ip_obs_slot
     il_fctstart = il_putend
     il_fctend = int(rd_daynum0) + il_tend
 
     !Put object Branch_one_put_29
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_29'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_assimtime, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_29,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_28
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_28'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_pastassimtime, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_28,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_22
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_22'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, ib_assim, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_22,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
     IF(ip_oma .eq. 1) THEN
!        ompute H(xa)
 
        !**START Branch --> Branch_obs
        cl_name = 'Branch_obs'
        CALL PALM_Start(cl_name, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_Start, branch Branch_obs'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
        id_obsmode=1
 
        !Put object Branch_one_put_21
        cl_space  = 'one_integer'
        cl_name   = 'Branch_one_put_21'
        il_time   = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, id_obsmode, il_err)
        IF (il_err.ne.0) THEN
            WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_21,PL_NO_TIME,PL_NO_TAG)'
            il_err2exp = il_err
            CALL PALM_error_explain(il_err2exp, il_err)
            CALL PALM_ABORT(il_err)
        END IF
 
     END IF
 
 
     !Put object Branch_one_put_2
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_2'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_tstart, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_2,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_20
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_20'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_tend, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_20,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_8
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_8'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_putstart, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_8,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_37
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_37'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_putend, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_37,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_12
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_12'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_fctstart, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_12,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !Put object Branch_one_put_14
     cl_space  = 'one_integer'
     cl_name   = 'Branch_one_put_14'
     il_time   = PL_NO_TIME
     il_usrtag = PL_NO_TAG
     CALL PALM_PUT(cl_space, cl_name, il_time, il_usrtag, il_fctend, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_PUT(one_integer,Branch_one_put_14,PL_NO_TIME,PL_NO_TAG)'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
 
 
     !**Launch unit --> MODEL_fcst
     cl_unit = 'MODEL_fcst'
     CALL PALM_Launch(cl_unit, il_err)
     IF (il_err.ne.0) THEN
         WRITE(PL_OUT,*)'Error in PALM_Launch, unit MODEL_fcst'
         il_err2exp = il_err
         CALL PALM_error_explain(il_err2exp, il_err)
         CALL PALM_ABORT(il_err)
     END IF
  END IF
 
 
  CALL PALM_Finalize(il_err)
 
END SUBROUTINE Branch_one
