C
C*** include file with the communication from the INIT unit
C
C** Automatic renaming of the ozone variable following the scheme
C** and the number of levels
C
#ifdef NIV_60
#ifdef CARIOLLE
#define CPP_O3 'O_3'
#else
#define CPP_O3 'O_x'
#endif
#else
#define CPP_O3 'O_x'
#endif
C
C** Read the list of the assimilates species in an auxiliary file
C
      WRITE(*,'(A30)') '++ READING ASSIMILATED SPECIES'
      WRITE(PL_OUT,'(A30)') '++ READING ASSIMILATED SPECIES'
      open( unit = 66,
     $    file = 'assimilated_species',
     $    form = 'formatted')
      DO ib = 1, NASSIM1
        iga_assim_idx(ib)=0
        READ(66,*) cga_assim_sp(ib)
        IF (TRIM(cga_assim_sp(ib)) .eq. 'O_3' .and.
     $      CPP_O3 .ne. 'O_3') THEN
            cga_assim_sp(ib)=CPP_O3
            WRITE(*,*) '+ WARNING CHANGING O_3 TO ',CPP_O3
            WRITE(PL_OUT,*) '+ WARNING CHANGING O_3 TO ',CPP_O3
        ENDIF
        IF (TRIM(cga_assim_sp(ib)) .eq. 'O_x' .and.
     $      CPP_O3 .ne. 'O_x') THEN
            cga_assim_sp(ib)=CPP_O3
            WRITE(*,*) '+ WARNING CHANGING O_x TO ',CPP_O3
            WRITE(PL_OUT,*) '+ WARNING CHANGING O_x TO ',CPP_O3
        ENDIF            
        IF (TRIM(cga_assim_sp(ib)) .eq. 'O_X') THEN
            cga_assim_sp(ib)=CPP_O3
            WRITE(*,*) '+ WARNING CHANGING O_X TO ',CPP_O3
            WRITE(PL_OUT,*) '+ WARNING CHANGING O_X TO ',CPP_O3
        ENDIF            
        IF (ig_run_mode .eq. DIR_MODEL) THEN
            DO ib_k = 1, NTRA1
              IF (TRIM(cga_assim_sp(ib)).eq.TRIM(TRANAM1(ib_k))) THEN
                  iga_assim_idx(ib)=ib_k
                  EXIT
              ENDIF
            END DO
            IF (iga_assim_idx(ib).le.0) THEN
                WRITE(*,*) '>> ERROR >>> Assimilated species ',
     $              TRIM(cga_assim_sp(ib))
                WRITE(*,*) '>>>>> NOT IN TRANAM1'
                WRITE(PL_OUT,*) '>> ERROR >>> Assimilated species ',
     $              TRIM(cga_assim_sp(ib))
                WRITE(PL_OUT,*) '>>>>> NOT IN TRANAM1'
                CALL PALM_Abort(il_err)
            ENDIF
        ENDIF
      END DO
      CLOSE(66) 
      WRITE(*,*) '+ ASSIMILATING THE FOLLOWING SPECIES :'
      WRITE(PL_OUT,*) '+ ASSIMILATING THE FOLLOWING SPECIES :'
      DO ib = 1, NASSIM1
        WRITE(*,*) '+ ', TRIM(cga_assim_sp(ib)),' in position ',
     $      iga_assim_idx(ib)
        WRITE(PL_OUT,*) '+ ', TRIM(cga_assim_sp(ib)),' in position ',
     $      iga_assim_idx(ib)
      ENDDO
C
C** Production of INIT output objects (cf id card for description)
C
      IF (ig_run_mode.EQ.DIR_MODEL .and. myid .eq. MASTER) THEN
C
        cl_space = 'one_real'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'rd_daynum0'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,daynum0,il_err)
C
        cl_space = 'date'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'ida_date0'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,idate0,il_err)
C
        cl_space = 'date'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'ida_date00'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,idate00,il_err)
C
        cl_space = 'one_real'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'rd_DT'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,DT,il_err)
C
        cl_space = 'one_integer'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'id_NEND'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,NEND,il_err)
C
        cl_space = 'one_integer'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'id_NOUT'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,NOUT,il_err)
C
        cl_space = 'one_integer'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'id_NCDF'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,NCDF,il_err)
C
        cl_space = 'one_integer'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'id_NSCY'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,NSCY,il_err)
C
        cl_space = 'one_integer'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'id_NITERT'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,NITERT,il_err)
C
        cl_domname(1:6) = TRIM(NAMDOM1)
        cl_space = 'dom_name'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'NAMDOM'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,cl_domname,
     &    il_err)
C
        cl_space = 'grid_lat'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'RLATM1'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,RLATM1,il_err)
C
        cl_space = 'grid_lon'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'RLONM1'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,RLONM1,il_err)
C
        cl_space = 'one_real'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'RLONM1_ORI'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,RLONM1(1),
     $      il_err)
C
        cl_space = 'sigma_coeff'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'ALM1'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,ALM1,il_err)
C
        cl_space = 'sigma_coeff'
        il_time = PL_NO_TIME
        il_usrtag = PL_NO_TAG
        cl_name = 'BLM1'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,BLM1,il_err)
C
      ENDIF
C
C** End of initialisation
C
      END
