ccccc
c     __________________________________________
c    |                                          |
c    | 7. OUTPUT HISTORY AND DIAGNOSTICS FILES  |
c    |__________________________________________|
c
ccccc
c
      IF (NCDF .gt. 0 .and. mod(SELAPS+int(DT),NCDF).eq.0.)
     $    call OUTNETCDF(daynum+DT,idate0,idate00,iterassim)
c
      IF(LOUT) THEN
          IF ((SELAPS+int(DT) .ge. ip_assimsize)
     $        .or. mod(SELAPS+int(DT),NOUT).eq.0) THEN
              ld_out = .TRUE.
          ELSE
              ld_out = .FALSE.
          ENDIF
          IF (ll_nooverlap) ld_out = .FALSE.
          IF (ld_out) THEN
              IF (SELAPS+int(DT) .ge. ip_assimsize .and.
     $            iterassim .eq. ip_nbfenet+1) THEN
C* write the restart file (no +Iww extension)
                  CALL OUTHISTO(daynum+DT,idate0,-1)
              ELSEIF(SELAPS+int(DT) .lt. ip_assimsize) THEN
C* write a FA/LFI output file (with +Iww extension)
                  CALL OUTHISTO(daynum+DT,idate0,iterassim)
              ENDIF
          ENDIF
      END IF
c
ccccc
c     _______________________________________________
c    |                                              |
c    | 8. PALM PUT CHEMISTRY SPECIES OVER THE GRID  |
c    |______________________________________________|
c
ccccc
C      
      IF (int(daynum+DT) .ge. il_putstart .and.
     $    int(daynum+DT) .le. il_putend) THEN

      IF (mod(int(daynum+DT),int(DT0)).EQ.0.and.myid.eq.master) THEN
C
C* Use the allocatable rda_sigmab array as a send buffer
C
        ALLOCATE( rda_sigmab(ip_lonm1,ip_latm1,ip_nivm1,ip_nassim))
C        
        DO ib = 1, ip_nassim
          rda_sigmab(:,:,:,ib) =
     $        QQQM1(:,:,:,iga_assim_idx(ib))
        END DO

C
        IF (ip_iprint .EQ. 1) THEN
            WRITE(*,*) 'Sending model state for ',int(daynum+DT)
            WRITE(PL_OUT,*) 'Sending model state for ',int(daynum+DT)
            CALL FLUSH(PL_OUT)
        END IF
        cl_space = 'controlled_species'
        il_time = int(daynum+DT)
        il_usrtag = PL_NO_TAG
        cl_name = 'rda_x'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
     +               rda_sigmab,il_err)
C
        DEALLOCATE (rda_sigmab)
C
        cl_space = 'ground'
        il_time = int(daynum+DT)
        il_usrtag = PL_NO_TAG
        cl_name = 'rda_psolm1'
        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,PSOLM1,il_err)
C      
      ENDIF 
C
      IF (ip_fenetre .EQ. ip_correctime .AND. 
     +    int(daynum) .EQ. (assimtime - ip_obs_slot).and.
     +    myid.eq.master) THEN
C
CAP January 6th 2007
CAP What's the hell is that too ?
CAP Maybe a residuate of the non overlapping restart ?
CAP To study better
CAP
        dQQQM1a = 0.
c      
        cl_space = 'controlled_species'
        il_time = assimtime 
        il_usrtag = PL_NO_TAG
        cl_name = 'rda_dxa'
        CALL PALM_Query_Put(cl_space,cl_name,il_time,il_usrtag,il_err)
        IF (il_ERR. eq. 0 ) CALL PALM_Put(cl_space,cl_name,il_time,
     +               il_usrtag,dQQQM1a,il_err)
CAPC
CAPC** Send the background error variance estimate
CAPC
CAP        ALLOCATE( rda_sigmab(ip_lonm1,ip_latm1,ip_nivm1,ip_nassim))
CAPC     
CAP        cl_space = 'one_integer'
CAP        il_time = assimtime 
CAP        il_usrtag = PL_NO_TAG
CAP        cl_name = 'il_sigmab'
CAP        CALL PALM_Get(cl_space,cl_name,il_time,il_usrtag,
CAP     +               il_sigbck,il_err)
CAPC        
CAP        DO ib = 1, ip_nassim
CAP          rda_sigmab(:,:,:,ib) =
CAP     $        QQQM1(:,:,:,iga_assim_idx(ib)) * REAL(il_sigbck)/100.
CAP        END DO
CAPC     
CAP        cl_space = 'controlled_species'
CAP        il_time = assimtime 
CAP        il_usrtag = PL_NO_TAG
CAP        cl_name = 'rda_sigmab'
CAP        CALL PALM_Put(cl_space,cl_name,il_time,il_usrtag,
CAP     +               rda_sigmab,il_err)
CAPC
CAP        DEALLOCATE( rda_sigmab )
      ENDIF
C
      ENDIF
C
C** Diagnostics (difference with independent observed data)
C
      IF (mod(NSECCY+int(DT),NSCY/NITERT).EQ.0.and.myid.eq.master) THEN
        IF ((int(daynum-daynum0)+DT0) .GE.iterassim*ip_fenetre) THEN
            ll_LASTTIME=.TRUE.
        ELSE
            ll_LASTTIME = .FALSE.
        END IF
        IF (int(daynum-daynum0).eq. 0 .or.
     +  int(daynum-daynum0).eq. ip_correctime+(iterassim-2)*ip_fenetre
     +  .or. (.NOT.ll_FIRSTTIME.and.int(daynum-daynum0).eq.(iterassim-1)
     +  *ip_fenetre)) THEN
            ll_FIRSTTIME = .TRUE.
        ELSE
            ll_FIRSTTIME = .FALSE.
        END IF
        IF (OBS) CALL MADONA(daynum-DT0+DT,idate0,iterassim,
     +      ll_FIRSTTIME,ll_LASTTIME)
      ENDIF
C
C*  Write out the difference at the end of the run
C
C      IF ((int(daynum-daynum0)+15*60).GE.iterassim*ip_fenetre .or.
C     +    (int(daynum-daynum0)+15*60).GE.ip_assimsize) THEN
       IF ((int(daynum-daynum0)+DT).GE.il_tend) THEN
         IF (OBS.and.myid.eq.master) 
     +        CALL WRTOBS(daynum+DT0,idate0,iterassim,.TRUE.)
      ENDIF
C
      END DO
