#!/bin/ksh
#
#=========================#
# Write the namelist file #
#=========================#
#
echo
echo '========================='
echo '>>> Script getnamelist.sh'
echo '========================='
#
#
YY0=`expr $DATEIN | cut -c1-4`
MM0=`expr $DATEIN | cut -c5-6`
JJ0=`expr $DATEIN | cut -c7-8`
HH0=`expr $DATEIN | cut -c9-10`
#
YY1=`expr $DATEOUT | cut -c1-4`
MM1=`expr $DATEOUT | cut -c5-6`
JJ1=`expr $DATEOUT | cut -c7-8`
HH1=`expr $DATEOUT | cut -c9-10`
#
if [ $CLEVELS -eq 0 ] ; then
	NLEVELS=0	
else
	set -A blocs `echo $LEVELS | awk -F ";" '{
	for (i=1;i<=NF;i++)
		print $i
	}'`

	set -A levels
	last=0
	ib=0
	while [ $ib -lt ${#blocs[@]} ] ; do

		set -A terms `echo ${blocs[ib]} | awk -F ":" '{
		for (i=1;i<=NF;i++)
			print $i
		}'`
		if [ ${terms[0]} -le $last ] ; then
    			echo "Level list should be monothonic!"
    			echo "Netcdf disabled!"
    			NCDF=-1
		fi

		if [ ${#terms[@]} -eq 2 ] ; then
        		set -A terms ${terms[@]} 1
		fi

		if [ ${#terms[@]} -eq 1 ] ; then
        		set -A terms ${terms[0]} ${terms[0]} 1
		fi

		set -A levels ${levels[@]} `echo ${terms[@]} | awk '{
		for (i=$1;i<=$2;i+=$3)
			print i
		}'`
		last=${terms[1]}
		ib=`expr $ib + 1`
	done
	NLEVELS=${#levels[@]}
fi
#
read DOM1 DOM2 DOM3 DOM4 < namedom
cat > namelist << EON
$YY0
$MM0
$JJ0
$HH0
$YY1
$MM1
$JJ1
$HH1
$NHCY
$NOUT
$NDOM
$DOM1
$DOM2
$DOM3
$DOM4
$CHEMSCHEME
$SOLID
$SURF
$PRMTRSP
$CLOUD
$OBS
$SRC
$TRANSINV
$NCDF
$INICDF
$CTOTCOL
$NLEVELS
EON
if [ $NCDF -gt 0 -a $NLEVELS -gt 0 ] ; then
echo ${levels[@]} | awk '{
for (i=1;i<=NF;i++)
print $i
}' >> namelist
fi

#
if [ $CSHORT -gt 0 ] ; then
echo $SPECIES | awk '{
print NF
for (i=1;i<=NF;i++)   
print $i
}' >> namelist
else
echo 0 >> namelist
fi
#
echo ">> The file namelist has been created for run from $DATEIN to $DATEOUT"
#
export YY0 MM0 JJ0 HH0 YY1 MM1 JJ1 HH1
